#include <pic16f876a.h>

#include "commun.h"

void setAdress(unsigned char adressLow, unsigned char adressHigh){
    // Adress High
    setAdressHigh(adressHigh);
    // Adress Low
    setAdressLow(adressLow);
}

void setAdressHigh(unsigned char adressHigh){
    // Adress High
    PORTB = adressHigh;
    PORTCbits.RC5 = 1;
    PORTCbits.RC5 = 0;
}

void setAdressLow(unsigned char adressLow){
    // Adress Low
    PORTB = adressLow;
    PORTCbits.RC4 = 1;
    PORTCbits.RC4 = 0;
}

void setControl(struct ControlBus controlBus){
    // Control High
    PORTB = controlBus.INT + controlBus.NMI*2 + controlBus.RESET*4 + controlBus.BUSRQ*8 + controlBus.BUSAK*16;
    PORTCbits.RC3 = 1;
    PORTCbits.RC3 = 0;
    // Control Low
    PORTB = controlBus.M1 + controlBus.MREQ*2 + controlBus.IOREQ*4 + controlBus.RD*8 + controlBus.WR*16 + controlBus.RFSH*32 + controlBus.HALT*64 + controlBus.WAIT*128;
    PORTCbits.RC2 = 1;
    PORTCbits.RC2 = 0;
}

void setData(unsigned char data){
    // Data
    PORTB = data;
    PORTCbits.RC1 = 1;
    PORTCbits.RC1 = 0;
}

unsigned char getData(){
    PORTCbits.RC0 = 1;
    PORTCbits.RC0 = 0;
    return PORTB;
}

void mettreAJourBusActifs(){
    char valeurPortA = 0;
    if ( busActifs.adressEtControl == 0 ){
        valeurPortA++;
    }
    if ( busActifs.sortieData == 0 ){
        valeurPortA = valeurPortA + 2;
    }
    if ( busActifs.entreeData == 0 ){
        valeurPortA = valeurPortA + 4;
    }
    PORTA = valeurPortA;
}
