/* 
 * File:   commun.h
 * Author: Jelora
 *
 * Created on 21 juin 2019, 22:03
 */

#ifndef COMMUN_H
#define	COMMUN_H

#define BUFFER_1_SIZE 96
#define BUFFER_2_SIZE 96
#define BUFFER_3_SIZE 64

unsigned char buffer1[BUFFER_1_SIZE];
unsigned char buffer2[BUFFER_2_SIZE];
unsigned char buffer3[BUFFER_3_SIZE];

struct BusActifs {
    char adressEtControl;
    char sortieData;
    char entreeData;
};

struct ControlBus {
    // System control
    char M1;
    char MREQ;
    char IOREQ;
    char RD;
    char WR;
    char RFSH;
    // CPU control
    char HALT;
    char WAIT;
    char INT;
    char NMI;
    char RESET;
    // CPU bus control
    char BUSRQ;
    char BUSAK;
};

void setAdress(unsigned char adressLow, unsigned char adressHigh);
void setAdressHigh(unsigned char adressHigh);
void setAdressLow(unsigned char adressLow);
void setControl(struct ControlBus controlBus);
void setData(unsigned char data);
unsigned char getData();
void mettreAJourBusActifs();



char progEnCours = 0;
struct BusActifs busActifs;
struct ControlBus controlBus;

// Valeur arbitraire correspondant au temps nécessaire via une boucle d'itération pour que chaque octet soit bien écrit en ROM
// 400 : OK pour AT28C64B-15PU
int temporisationEcriture = 400;

#endif

